const char version[] = "1.20";		// changer ce numéro pour version
#define Courant_Max 1000					// courant maximum avant disjonction 
#define Boucle_Lec_Courant 2		// 2 origine boucle de lecture courant
#define tempo_CC 200						// nb de millisecondes avant rétablissement tension DCC
//#define YESICAN 								// à commenter si pas de module CAN installé mais NRF fonctionne mieux si module CAN installé
/*
Attention!!! Modification de la librairie DCCpp
			Dans config.h ligne 23: MAX_MAIN_REGISTERS passe de 12 à 24
			Dans PacketRegister.cpp 
				suppression affichage moniteur lignes 144 à 151, 199 à 206, 382 à 392, 490 à 500 
			
<1>: Allumez les pistes (Main et Programmation).
<0>: Éteignez les pistes (Main et Programmation).
<S>: Liste tous les capteurs définis.
<T>: Liste tous les aiguillages définis.
<Z>: Répertorie toutes les broches de sortie définies
<Q>: Listes État de tous les capteurs.
<E>: Stocker les définitions dans l'EEPROM
<e>: Effacement de toutes les définitions (aiguillages, capteurs et sorties) de l'EEPROM

<f>: Controle des fonctions F0-F28 d'une loco
<a>: Controle des décodeurs d'accessoires
<w>: writes a configuration variable byte to an engine decoder on the main ops track
<b>: sets/clear a configuration variable bit in an engine decoder on the main operations track
<B>: sets/clear a configuration variable bit in an engine decoder on the programming track
<c>: reads current draw from main operations track
<s>: returns status messages, including power state, turnout states, and sketch version

<T ID ADDRESS SUBADDRESS> ID=0-32767, ADDRESS=0-511, SUBADDRESS=0-3 pour définir un aiguillage avec <E>
<T ID>	supprime cet ID  avec <E>
<T ID 0> ou <T ID 1> change la position de l'aiguillage
Renvoie: <O> en cas de succès et <X> en cas d'échec (par exemple, mémoire insuffisante)

Entrée <S 1001 8 1>	met le bit 8 en entré avec pullup: Si enregistré, répond <Q1001> si 0 et <q1001> si 1
<S 1001>	supprime cet ID puis faire <E>
à chaque changement d'état du capteur <Q1001> ou <q1001> est renvoyé
Renvoie: <Q ID PIN PULLUP> pour chaque capteur défini ou si aucun capteur n'est défini

Sortie <Z 1000 8 0> défini la sortie 8 avec ID 1000 et met la sortie 8 à 0: A faire pour chaque sortie puis <E>
<Z 1000>	supprime cet ID, puis faire <E>
<Z 1000 1>	met la sortie avec l'ID 1000 à 1
<Z 1000 0>	met la sortie avec l'ID 1000 à 0
Renvoie: <O> en cas de succès et <X> en cas d'échec

<W 1 3 100 101>	écrit sur voie de programmation l'adresse 3 dans CV1 (100 et 101 arbitraire)
Renvoie: <r 100 101 3> (le 3 est remplacé par -1 si écriture a échoué ??????? à voir) 

<R 1 100 101>	Lit sur voie de programmation la valeur de CV1 (100 et 101 arbitraire)
Renvoie: <r 100 101 1 3>  (le 3 est remplacé par -1 si lecture a échoué)

<t 1 3 30 1>	Locomotive ayant pour adresse "3" avancer à la vitesse de 30 en avant dans registre 1.
<t 1 3 30 0>	Locomotive ayant pour adresse "3" avancer à la vitesse de 30 en arrière dans registre 1.
<t 1 3 0 0>		Locomotive à l'arrêt
<t 1 3 -1 0>	Arrêt d'urgence (pas de ralentissement)
Renvoie <T 1 30 1>

<f 3 144>	Allume la lumière en avant
<f 3 128>	Tout éteint
Pas de retour
F0 (lumière) = 16, F1 (cloche) = 1, F2 (corne) = 2, F3 = 4, F4 = 8
Tout éteint = 128
Lumière sur 128 + 16 = 144
Lumière et cloche sur 128 + 16 + 1 = 145
Lumière et cor sur 128 + 16 + 2 = 146
Juste corne 128 + 2 = 130

/************************************************************************************
 Centrale DCC MEGA avec réception des ordres possible par CAN, NRF24L01 ou Bluetooth	
************************************************************************************/
/*
// Format de réception commande DCC par bus CAN (voir sketch Carte_DCCpp_CAN_emetteur.ino)
	format un peu particulier car message CAN comprend maximum 8 caractères
	l'adresse est reconstruite par la routine restaure_adr()
	data_send[0] = 60;	// = '<'
	data_send[1] = 116;	// = 't'
	data_send[2] = v1;	// = 1 non ascii registre interne
	data_send[3] = AdH;	// = 0 non ascii adresse courte ou longue HIGH
	data_send[4] = AdL;	// = 3 non ascii adresse courte ou longue LOW
	data_send[5] = v3;	// = 30 non ascii vitesse en crans
	data_send[6] = v4;	// = 1 non ascii marche avant
	data_send[7] = 62;	// = '>'

	ou
	
	data_send[0] = 60;	// = '<'
	data_send[1] = 102;	// = 'f'
	data_send[2] = AdH;	// = 0 non ascii adresse courte ou longue HIGH
	data_send[3] = AdL;	// = 3 non ascii adresse courte ou longue LOW
	data_send[4] = v2;	// = 144 non ascii
	data_send[5] = 62;	// = '>'
	
	ou
	
	data_send[0] = 60;	// = '<'
	data_send[1] = 48;	// = '0'		// ou '1'
	data_send[2] = 62;	// = '>' 

// Format d'émission sur bus CAN des fonctions > 28
	1 octet qui est le N° de la fonction avec le bit 7 à 1 si la fonction est activée
	
	
// Format d'émission état DCC (4 bytes)
	<T0> = hors tension
	<T1> = DCC
	<T2> = court-circuit

// Format réception des fonctions (4 bytes)
	<Fn> F en byte, n = byte de 00 à 99, bit 7 de n à 1 si fonction active

// Format réception des crans (7 bytes)
	<thlcvs> = t en byte, h = byte H de adresse, l = byte L de adresse, c = crans, v = byte vitesse, s = byte sens
	
// Format DCC des fonctions
	<f CAB BYTE1 [BYTE2]>
	
// Format DCC des fonctions
	<f CAB BYTE1 [BYTE2]>
	
	F0-F4 : BYTE1: 128 + (F1 * 1) + (F2 * 2) + (F3 * 4) + (F4 * 8) + (F0 * 16)
	128 = 10000000
	
	F5-F8 : BYTE1: 176 + (F5 * 1) + (F6 * 2) + (F7 * 4) + (F8 * 8)
	176 = 10110000
	
	F9-F12 : BYTE1: 160 + (F9 * 1) + (F10 * 2) + (F11 * 4) + (F12 * 8)
	160 = 10100000
	
	F13-F20 : BYTE1: 222
						BYTE2: (F13*1) + (F14*2) + (F15*4) + (F16*8) + (F17*16) + (F18*32) + (F19*64) + (F20*128)
	
	F21-F28 : BYTE1: 223
						BYTE2: (F21*1) + (F22*2) + (F23*4) + (F24*8) + (F25*16) + (F26*32) + (F27*64) + (F28*128)
*/

#include "DCCpp.h"

#ifndef USE_TEXTCOMMAND
#error To be able to compile this sample,the line #define USE_TEXTCOMMAND must be uncommented in DCCpp.h
#endif

#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>

#ifdef YESICAN
#include <mcp_can.h>
#endif

const unsigned int ad_reception_carte1	= 0x100;		
const unsigned int ad_reception_carte2 	= 0x101;		
const unsigned int ad_emission_carte1		= 0x200;	// carte son et pont tournant	  	
const unsigned int ad_emission_carte2		= 0x300;	
const unsigned int nb_char_recu		= 8;	// nombre de caractères à reçevoir
const unsigned int nb_char_emis		= 1;	// nombre de caractères à emettre
boolean _dumpCan = true;								// mode débogage

// mesure du courant DCC
#define DCC_ENABLE 3
#define DCC_PROG_ENABLE 11
byte cpt_CurrentMax = 0;

// Le NRF24L01
#define CE_PIN  8
#define CSN_PIN 7
RF24 radio(CE_PIN, CSN_PIN); 

const uint64_t pipes[] = {0xB3B4B5B601LL, 0xB3B4B5B612LL, 0xB3B4B5B623LL, 0xB3B4B5B634LL, 0xB3B4B5B645LL, 0xB3B4B5B656LL};
// const uint64_t pipes[] = {0xB3B4B5B667LL, 0xB3B4B5B678LL, 0xB3B4B5B689LL, 0xB3B4B5B69ALL}; // canaux pour pour carte additionnelle
char text1[3] = {'T', '0'};
byte pipeNum = 0; 		//variable qui renvoi le N° de la souris appelante (0 à 5)
byte dcc_receive[9];

// locos
#define nb_max_locos 12		// Nb de locos max mises en mémoire
boolean envoi[6];
unsigned int adr_cv[6];
unsigned int sav_don_cv[6];
unsigned int don_cv;
byte vitesse = 0;
byte crans = 0;
boolean sens = false;
unsigned int adresse_loco;
byte adr_loco_H = 0;
byte adr_loco_L = 0;

// fonctions
FunctionsState gLocoFunctions[12];

unsigned long date_dernier_fct = 0;
char code_fct[2] ;
unsigned int  num_fct;
unsigned int  etat_fct;
boolean fonction[nb_max_locos + 1][30];
char dcc_fonction[16];	// max "<f lll 222 128>"
byte fonc_B0_4 = 128;	
byte fonc_B5_8 = 176;	
byte fonc_B9_12 = 160;	
const byte fonc_B0_43_1 = 222;	
byte fonc_B0_43_2 = 0;	
const byte fonc_B0_28_1 = 223;	
byte fonc_B0_28_2 = 0;	
byte nb_loc = 0;
byte ordre_loc = 0;
unsigned int adr_loc[nb_max_locos+1];			// tableau des adresses pour gérer fonctions
// ces tableaux sont mis à 0 à chaque démarrage et remplis au fur et à mesure de l'utilisation
// d'une nouvelle loco. Si les 12 sont dépassées, on fait un RAZ du tableau
byte tab_fonc_B0_4[nb_max_locos + 1];			// tableau des fonctions de 0 à 4 pour 12 locos
byte tab_fonc_B5_8[nb_max_locos + 1];			// tableau des fonctions de 5 à 8 pour 12 locos
byte tab_fonc_B9_12[nb_max_locos + 1];		// tableau des fonctions de 9 à 12 pour 12 locos
byte tab_fonc_B0_43_2[nb_max_locos + 1];	// tableau des fonctions de 13 à 20 pour 12 locos
byte tab_fonc_B0_28_2[nb_max_locos + 1];	// tableau des fonctions de 21 à 28 pour 12 locos

#ifdef YESICAN
// variables globales pour l'interface CAN
const int SPI_CS_PIN = 53;				//  On n'a pas le choix pour le bus CAN: c'est la broche 53
MCP_CAN CAN(SPI_CS_PIN);    			//  déclaration de la broche Chip Select du MCP 2111
volatile byte Flag_Recv = 0;   		// variable d'échange avec l'interruption IRQ

// Variable globale Mémoire circulaire pour le stockage des messages reçus
unsigned char _Circule[256];    	// récepteur circulaire des messages CAN sous IT
int _indexW, _indexR, _Ncan;    	// index d'écriture et lecture, nb d'octets a lire
byte _CANoverflow = 0;          	// flag overflow (buffer _Circule plein)
unsigned char len = 0;  					// nombre d'octets du message
unsigned int Id;   								// Id (on devrait plutôt utiliser un int car il y a 11 bits)
unsigned char Id_H = 0;  					// Id poids fort
unsigned char Id_L = 0;  					// Id poids faible
#endif

// variables pour le traitement des messages lus dans _Circule
int RId;  
byte Rlen;
byte data_send[nb_char_emis];     //  max 1 octets de données envoyées
byte Rbuf[nb_char_recu];					//  max 8 octets de données reçues
byte data_receive[nb_char_recu];  //  max 8 octets de données reçues
byte ancien_buf[nb_char_recu];    //  Anciennes données reçues
String cmdString;

byte ordres_carte1 = 0;
byte old_ordres_carte1 = 0;
byte ordres_carte2 = 0;
byte old_ordres_carte2 = 0;
byte etat_carte1[8];
byte etat_carte2[8];

// divers
byte etat = 0;													// hors tension au reset
byte old_etat = 0;
char cmdBlue[MAX_COMMAND_LENGTH + 1];		// message reçu par Bluetooth
byte cpt_cc = 0;												// compteur de court-circuit (3 boucles de 0,5s)
unsigned long date_dernier_cc = 0;			// tempo pour court-circuit

#ifdef YESICAN
/***********************************************************************************
// Routine d'Interruption par CAN
/***********************************************************************************/
void MCP2515_ISR()
{
	Flag_Recv = 1;
}
#endif

//**********************************************************************************
// SETUP 
//**********************************************************************************
void setup()
{
  Serial.begin(115200);
  Serial1.begin(9600);
	Serial.print("Version = ");
	Serial.println(version);
	
#ifdef YESICAN
START_INIT:
	if(CAN_OK == CAN.begin(CAN_250KBPS)) {        // init can bus : baudrate = 250k
		if(_dumpCan) {
			Serial.println("CAN BUS Shield init ok!");
		}
	}
	else	{
		if(_dumpCan) {
			Serial.println("CAN BUS Shield init fail");
		}
		delay(100);
		goto START_INIT;
	}

	/*
	 * configurer mask & filter du bus CAN
	 */
	CAN.init_Mask(0, 0, 0b11111111111);  					// Il y a 2 masques à initialiser dans le mcp2111
	CAN.init_Mask(1, 0, 0b11111111111);  					// on teste tous les bits 
 
	CAN.init_Filt(0, 0, ad_reception_carte1);    	// Reception possible : que 2 adresses
	CAN.init_Filt(1, 0, ad_reception_carte1);     // idem
	CAN.init_Filt(2, 0, ad_reception_carte1);     // idem
	CAN.init_Filt(3, 0, ad_reception_carte2);     // idem
	CAN.init_Filt(4, 0, ad_reception_carte2);        // idem
	CAN.init_Filt(5, 0, ad_reception_carte2);        // Idem	
	
	// configurer l'interruption
	attachInterrupt(2, MCP2515_ISR, FALLING); // interrupt 2 (pin 21)
#endif
	// lancement radio
	radio.begin();
  radio.setPALevel(RF24_PA_MAX);			//RF24_PA_MIN, RF24_PA_LOW, RF24_PA_HIGH and RF24_PA_MAX
	radio.setChannel(108); 							//canal 108 au dessus des canaux WiFi  (de 0 à 125)
  radio.setDataRate( RF24_250KBPS ) ;

  // ouvrir 6 canaux de réception radio
  radio.openReadingPipe(0,pipes[0]);
  radio.openReadingPipe(1,pipes[1]);
  radio.openReadingPipe(2,pipes[2]);
  radio.openReadingPipe(3,pipes[3]);
  radio.openReadingPipe(4,pipes[4]);
  radio.openReadingPipe(5,pipes[5]);

  radio.startListening();	// passer en réception

	// Lancement DCC
	DCCpp::begin();
	DCCpp::beginMain(UNDEFINED_PIN, DCC_SIGNAL_PIN_MAIN, 3, UNDEFINED_PIN );	//en mettant UNDEFINED_PIN à la place de A0,plus de test de courant par DCC, il y a une routine spécifique dans le loop
	DCCpp::beginProg(UNDEFINED_PIN, DCC_SIGNAL_PIN_PROG, 11, A1);
	DCCpp::setCurrentSampleMaxProg(300); 	
	Serial.println("SerialDcc OK");

	// mise à 0 des tableaux de fonctions et adresses locos
	for (int nb_loc = 0; nb_loc < nb_max_locos; nb_loc++) {	
		adr_loc[nb_loc] = 0;
		tab_fonc_B0_4[nb_loc] = 128;
		tab_fonc_B5_8[nb_loc] = 176;
		tab_fonc_B9_12[nb_loc] = 160;
		tab_fonc_B0_43_2[nb_loc] = 0;
		tab_fonc_B0_28_2[nb_loc] = 0;
	}
	
	// envoyer l'info tension coupée sur les souris
	//start_DCC();	// si demande de tension DCC à l'allumage, décommenter cette ligne
	envoi_etat();
}

//**********************************************************************************
//  LOOP 
//**********************************************************************************
void loop()
{    

//----------------------------------------------
// gestion du DCC
//----------------------------------------------
	DCCpp::loop();

//----------------------------------------------
// test si reception radio
//----------------------------------------------
  if (radio.available(&pipeNum))  {			// tester si une trame est arrivée, 
		char c_cv[2];
    radio.read(&dcc_receive, sizeof(dcc_receive));		// sizeof(dcc_receive) est toujours à 8
		Serial.println(dcc_receive[1]);
		Serial.println(dcc_receive[2]);
		Serial.println(dcc_receive[3]);
		Serial.println(dcc_receive[4]);
		Serial.println(dcc_receive[5]);
		Serial.println(dcc_receive[6]);
		if(dcc_receive[0] == '<') {	// ne traiter que si trame commence par <
			if(dcc_receive[1] == 1) {					// "1" = trame allumer DCC
				start_DCC();										// utiliser de ce programme pour allumer DCC
				cpt_cc = 0;											// permettre à nouveau 3 CC de 0,5s
				old_etat = 10;									// pour forcer l'envoi de l'état
				delay(100);											// laisser le temps à la souris de passer en réception
			}
			else if(dcc_receive[1] == 0) {		// "0" = trame couper DCC
				stop_DCC();											// utiliser de ce programme pour couper DCC
				old_etat = 10;									// pour forcer l'envoi de l'état
				delay(100);											// laisser le temps à la souris de passer en réception
			}
			else {
				if(dcc_receive[1] == 't') {			// 't' = trame vitesse
					adr_loco_H = dcc_receive[2];
					adr_loco_L = dcc_receive[3];
					adresse_loco = restaure_adr();	// restaure l'adresse complète à partir de HI et LOW
					crans = dcc_receive[4];					// 0 = 128 crans, autre = 28 crans
					vitesse = dcc_receive[5];				// vitesse
					sens = dcc_receive[6];					// 1 = marche avant
					enregistre_loc();	// enregistre la nouvelle loco ou récupère son ID si existe
					// ici on change de registre de vitesse selon loco, ne pas utiliser registre 0 donc +1
					if(crans == 0) {
						DCCpp::setSpeedMain(ordre_loc + 1, adresse_loco, 128, vitesse, sens);  
					}
					else {
						DCCpp::setSpeedMain(ordre_loc + 1, adresse_loco, 28, vitesse, sens);  
					}
				}
				else if(dcc_receive[1] == 'W') {	// "W" = trame écriture CV sur voie de programmation
					envoi[pipeNum] = true;	// pour forcer un retour du résultat
					adr_cv[pipeNum] = dcc_receive[2];
					// assembler les 2 bytes pour refaire valeur INT
					adr_loco_H = dcc_receive[3];
					adr_loco_L = dcc_receive[4];
					don_cv = restaure_adr();	// restaure valeur complète à partir de HI et LOW
					if(adr_cv[pipeNum] == 1 and don_cv < 128) {	
						// c'est une adresse courte pour cv1
						DCCpp::writeCvProg(adr_cv[pipeNum], don_cv, 100, 200);	// écriture de CV1
						// mettre bit 5 de CV29 à 0 pour adresse courte
						byte cv_29 = DCCpp::readCvProg(29, 100, 200);
						bitWrite(cv_29, 5, 0);
						DCCpp::writeCvProg(29, cv_29, 100, 200); 
					}
					else if(adr_cv[pipeNum] == 1) {	
						// c'est une adresse longue pour cv1, donc on calcul les valeurs de CV17 et CV18
						int deb=0;
						int fin=0;
						int res=0;
						int cv17=192;	// laisser cv17 à 192 pour calcul
						int cvres=0;
						for (int i = 0;i <= 9984;i = i + 256) {
							deb = i;
							fin= i + 255;
							if ((don_cv >= deb)&&(don_cv <= fin)){
							res = don_cv - i;
							cvres = cv17;
							}
							cv17 = cv17 + 1;
						}
						// mettre bit 5 de CV29 à 1 pour adresse longue
						byte cv_29 = DCCpp::readCvProg(29, 100, 200);
						bitWrite(cv_29, 5, 1);
						DCCpp::writeCvProg(29, cv_29, 100, 200); 
						DCCpp::writeCvProg(17, cvres, 100, 200);	// écriture de CV17
						DCCpp::writeCvProg(18, res, 100, 200);		// écriture de CV18
					}
					else {	// pour tous les autres cv, envoyer trame
						DCCpp::writeCvProg(adr_cv[pipeNum], don_cv, 100, 200);
					}
				}
				else if(dcc_receive[1] == 'R') {	// "R" = trame lecture CV
					adr_cv[pipeNum] = dcc_receive[2];
					envoi[pipeNum] = true;			// la lecture se fait dans test envoi[pipeNum]
				}
				else if(dcc_receive[1] == 'f') {	// "f" = trame fonctions locos
					adr_loco_H = dcc_receive[2];
					adr_loco_L = dcc_receive[3];
					adresse_loco = restaure_adr();	// restaure l'adresse complète à partir de HI et LOW
					etat_fct = bitRead(dcc_receive[4], 7);// le sens est déterminé par le bit 7 de vitesse
					num_fct = dcc_receive[4] & 0b01111111 ;	// mettre bit 7 à 0
					if(num_fct < 29) {	// n'envoyer sur loco que les 28 premières fonctions
						enregistre_loc();	// enregistre la nouvelle loco ou récupère son ID si existe
						// envoyer la fonction
						if (etat_fct) {
							gLocoFunctions[ordre_loc].activate(num_fct);
						} else {
							gLocoFunctions[ordre_loc].inactivate(num_fct);
						}
						// MAJ registre loco
						DCCpp::setFunctionsMain(ordre_loc + 13, adresse_loco, gLocoFunctions[ordre_loc]);
					}
					else {	// les fonctions > 28 sont envoyées sur bus CAN avec bit 7 en l'état
						ordres_carte1 = dcc_receive[4];
					}
				}
				else if(dcc_receive[1] == 119) {	// "w" = trame programmation POM
					adr_cv[pipeNum] = dcc_receive[2];
					don_cv = dcc_receive[3];
					DCCpp::writeCvMain(adr_cv[pipeNum], don_cv, 100, 200);
				}
			}
		}
  }

	if (envoi[pipeNum] and etat) {	// récupérer la donnée à lire à l'adresse adr_cv et l'envoyer par radio mais que si loco sous tension (etat = true)
		char text[7];
		if(adr_cv[pipeNum] == 1) {	// si on lit le CV1, tester si adresse longue ou non
			int CV_29 = DCCpp::readCvProg(29,101,101);	//
			int CV_17 = DCCpp::readCvProg(17,101,101);	//
			int CV_18 = DCCpp::readCvProg(18,101,101);	//
			if(bitRead(CV_29,5) == 1) {	// on est en adresse longue
				sav_don_cv[pipeNum] = ((CV_17 - 192) * 256 ) + CV_18;	// reconstruire adresse longue
				sprintf(text,"R%d",sav_don_cv[pipeNum]);	// on renvoi l'adresse longue lue					
			}
			else {
				int monINT = DCCpp::readCvProg(adr_cv[pipeNum],101,101); // lecture CV1 (adr courte)	
				sprintf(text,"R%d",monINT);						// réponse bonne ou fausse
			}
		}
		else {	// si on lit les autres CV, retourner simplement sa lecture
			int monINT = DCCpp::readCvProg(adr_cv[pipeNum],101,101); // lecture du CV demandé	
			sprintf(text,"R%d",monINT);					// réponse bonne ou fausse
		}
		radio.stopListening();								// passer en émission
    radio.openWritingPipe(pipes[pipeNum]); // utiliser le canal de celui qui a envoyé la demande
		radio.write(&text, sizeof(text));
		delay(5);
		radio.startListening();								// passer en réception
		envoi[pipeNum] = false;
	}

//----------------------------------------------
// test si trame arrive par série 1 (Bluetooth)
//----------------------------------------------
	while (Serial1.available()>0) {    // Tant que données série arrivent
		char c = Serial1.read();
		//Serial.print(c);
		if (c == '<') {                    // début de la trame
			cmdBlue[0] = 0;
		}
		else if (c == '>') {              // fin de la trame
			TextCommand::parse(cmdBlue); // on envoie traiter la trame
		}
		else if (strlen(cmdBlue) < MAX_COMMAND_LENGTH) {	// s'il reste de la place dans le tableau
			sprintf(cmdBlue, "%s%c", cmdBlue, c);						// continuer jusqu'au >
		}
	} 
	
#ifdef YESICAN
//-------------------------------------------------------------------------------------------
// Test si message CAN reçu par IRQ
//-------------------------------------------------------------------------------------------
  if (Flag_Recv)  {
    Flag_Recv = 0;  // Flag MCP2111 prêt pour un nouvel IRQ
    CAN_recup();    // récupération du ou des messages CAN reçus
  }
	
//-------------------------------------------------------------------------------------------
// Test si nouvelles données à envoyer aux cartes
//-------------------------------------------------------------------------------------------
	if (ordres_carte1 != 0) {
    if (_dumpCan)  {     	
			Serial.print("Envoi Nouvelle données: ");
			Serial.println(ordres_carte1,BIN);
		}
		data_send[0] = ordres_carte1;
		// Envoie de data sur le bus CAN:  id = ad_emission_carte1, trame standard, 1 octets, data
		CAN.sendMsgBuf(ad_emission_carte1, 0, 1, data_send);
		ordres_carte1 = 0;
	}

//-------------------------------------------------------------------------------------------
// Traitement des messages reçus et stockés dans la mémoire circulaire _Circule
//-------------------------------------------------------------------------------------------
  while (_Ncan > 3)  {    // chaque message occupe au moins 4 octets, 11 bits + Nb_octets + 1 octet
    _Ncan--;
    Id_H = _Circule[_indexR];        // recup Id poids fort
    _indexR++;
    _Ncan--;
    Id_L = _Circule[_indexR];        // recup Id poids faible
    _indexR++;
		// reconstruire Id 12 bits
		RId = Id_H;
		RId = RId << 8;
		RId = RId + Id_L;
    if (_indexR == sizeof(_Circule))  {_indexR = 0;}
    _Ncan--;
    Rlen = _Circule[_indexR];       // recup longueur
    _indexR++;
    if (_indexR == sizeof(_Circule))  {_indexR = 0;}
    if (_dumpCan)  {     	 // _dumpCan est un boolean a déclarer en globale 
			Serial.println();
      Serial.print("Message recu : CAN id = ");	// si on veut conditionner l'affichage des message
      Serial.print(RId,HEX);
      Serial.print(", data ");
    }
    for (int k = 0; k < Rlen; k++)  {
      _Ncan--;
      Rbuf[k] = _Circule[_indexR];  // recup octets message
      _indexR++;
      if (_indexR == sizeof(_Circule))  {_indexR = 0;}
      if (_dumpCan)  {  
				Serial.print(" - ");
				Serial.print(Rbuf[k]);
      }
    }
    if (_dumpCan) Serial.println();

		// le message est maintenant dans les globales RId, Rlen et Rbuf[..]
    if(RId == ad_reception_carte1) {	// instruction de vitesse venant de carte 1
			if(Rbuf[0] == 60  and Rbuf[Rlen-1] == 62) {	// ne traiter que si encadré par < et >
				if(Rlen == 8) {	// réception d'une instruction de vitesse
					cmdString = String(char(Rbuf[1])) + " ";	// (t) caractère en ascii
					cmdString = cmdString + String(Rbuf[2]) + " ";	// 1 registre
					adr_loco_H = Rbuf[3];	// valeur H de l'adresse
					adr_loco_L = Rbuf[4];	// valeur LOW de l'adresse
					adresse = restaure_adr();				// retourne l'adresse complète dans adresse
					cmdString = cmdString + String(adresse) + " ";	// adresse complète loco
					cmdString = cmdString + String(Rbuf[5]) + " ";	// vitesse en crans
					cmdString = cmdString + String(Rbuf[6]);	// 1 marche avant

					// for (int k = 2; k <= (Rlen-2); k++)  {
						// cmdString = cmdString + String(Rbuf[k]) + " ";	// les autres nombre en lettres
					// }
					char cmdChar[cmdString.length()+1]; // tableau de char de la taille du String cmdString + 1 (caractère de fin de ligne) 
					cmdString.toCharArray(cmdChar,cmdString.length()+1); // récupère le string dans le tableau de char 
					if (_dumpCan)  {     	 // _dumpCan est un boolean a déclarer en globale 
						Serial.println(cmdChar);
					}
					TextCommand::parse(cmdChar); // on envoie traiter la trame
				}
				else if(Rlen == 6) {	// réception d'une instruction de lumière
					cmdString = String(char(Rbuf[1])) + " ";	// (t) caractère en ascii
					adr_loco_H = Rbuf[2];	// valeur H de l'adresse
					adr_loco_L = Rbuf[3];	// valeur LOW de l'adresse
					adresse = restaure_adr();				// retourne l'adresse complète dans adresse
					cmdString = cmdString + String(adresse) + " ";	// adresse complète loco
					cmdString = cmdString + String(Rbuf[4]) + " ";	// cde lumière
					char cmdChar[cmdString.length()+1]; // tableau de char de la taille du String cmdString + 1 (caractère de fin de ligne) 
					cmdString.toCharArray(cmdChar,cmdString.length()+1); // récupère le string dans le tableau de char 
					if (_dumpCan)  {     	 // _dumpCan est un boolean a déclarer en globale 
						Serial.println(cmdChar);
					}
					TextCommand::parse(cmdChar); // on envoie traiter la trame
				}
				else if(Rlen == 3) {	// réception d'une instruction de marche/arrêt
					cmdString = String(char(Rbuf[1])) + " ";	// (0 ou 1) caractère en ascii
					char cmdChar[cmdString.length()+1]; // tableau de char de la taille du String cmdString + 1 (caractère de fin de ligne) 
					cmdString.toCharArray(cmdChar,cmdString.length()+1); // récupère le string dans le tableau de char 
					if (_dumpCan)  {     	 // _dumpCan est un boolean a déclarer en globale 
						Serial.println(cmdChar);
					}
					TextCommand::parse(cmdChar); // on envoie traiter la trame
				}
			}
		}
    if(RId == ad_reception_carte2) {
			for (int k = 0; k < Rlen; k++)  {
				_Ncan--;
				Rbuf[k] = _Circule[_indexR];  // recup octets message
				_indexR++;
				if (_indexR == sizeof(_Circule))  {_indexR = 0;}
				if (_dumpCan)  {  
					Serial.print(" - ");
					Serial.print(Rbuf[k]);
				}
			}
			if (_dumpCan) Serial.println();
    }
    break;
	}
#endif
	
//-------------------------------------------------------------------------------------------
// Mesure du courant DCC
//-------------------------------------------------------------------------------------------
  int iCurrent = analogRead(A0);
	//Serial.println(iCurrent);
	if (iCurrent > Courant_Max ) { 		// 0,9 A lit 208 sur A0
		cpt_CurrentMax++;
		if (cpt_CurrentMax > Boucle_Lec_Courant) { 	// x boucles avec valeur dépassée = couper DCC
			stop_DCC();
			cpt_CurrentMax = 0;
			cpt_cc++;
			if(cpt_cc > 3) {
				etat = 2;										// on coupe définitivement le jus
			}
			else {
				date_dernier_cc = millis();	// sinon on recharger tempo CC pour remettre le jus
			}
		} 
	}
	else {
		cpt_CurrentMax = 0;
	}

//-------------------------------------------------------------------------------------------
// Test s'il faut remettre le jus (mais que si on l'a déjà coupé) 
//-------------------------------------------------------------------------------------------
	if(cpt_cc > 0) {
		if((millis() - date_dernier_cc) > tempo_CC and cpt_cc < 4) {
			start_DCC();								// on remet le jus
		}	
	}

//-------------------------------------------------------------------------------------------
// Envoi par radio si état tension DCC à changé
//-------------------------------------------------------------------------------------------
	if(etat != old_etat) {
		text1[0] = 'T';
		switch (etat) {
			case 0: {    
				text1[1] =  '0';	// hors tension
				break;
				}
			case 1:	{    
				text1[1] =  '1';	// sous tension
				break;
				}
			case 2: {   
				text1[1] =  '2';	// court-circuit
				break;
				}
		}
		// envoyer l'état sur toutes les souris
		envoi_etat();
		delay(5);
		radio.startListening();	// passer en réception
		old_etat = etat;
	}

//-------------------------------------------------------------------------------------------
// Vérifier si tension DCC à changée par CAN ou Bluetooth ou Série
//-------------------------------------------------------------------------------------------
  if(digitalRead(DCC_ENABLE) == HIGH) {
		etat = 1;
	}
	else if(etat != 2) {		// ne pas modifier etat si court-circuit
		etat = 0;
	}

}	// fin loop

//**********************************************************************************
// Sous-programmes
//**********************************************************************************

#ifdef YESICAN
//-------------------------------------------------------------------------------------------
// Routine de récupération des messages CAN dans la mémoire circulaire _Circule
//-------------------------------------------------------------------------------------------
void CAN_recup()
{
	while (CAN_MSGAVAIL == CAN.checkReceive())  {
		CAN.readMsgBuf(&len, data_receive);        // read data, len: data length, buf: data buf
		Id = CAN.getCanId();
		// séparer Id en poids fort et faible
		Id_L = Id ;
		Id_H = Id >> 8;
		if ((_Ncan+len+3) < sizeof(_Circule))  { // il reste de la place dans _Circule
			_Circule[_indexW] = Id_H;         // enregistrement de Id
		_indexW++;
			_Ncan++;
			_Circule[_indexW] = Id_L;         // enregistrement de Id
		_indexW++;
			_Ncan++;
			if (_indexW == sizeof(_Circule))  {_indexW = 0;}
			_Circule[_indexW] = len;        // enregistrement de len
			_indexW++;
			_Ncan++;
			if (_indexW == sizeof(_Circule))  {_indexW = 0;}
			for (byte z = 0; z<len; z++)  {
				_Circule[_indexW] = data_receive[z];    // enregistrement du message
				_indexW++;
				_Ncan++;
				if (_indexW == sizeof(_Circule))  {_indexW = 0;}
			}
		} 
		else 
		{
				_CANoverflow = 1;  // dépassement de la capacite de Circule
				if (_dumpCan) Serial.println("Dépassement buffer");
		}
	} 
}	
#endif

//-------------------------------------------------------------------------------------------
// Routine de mise sous tension
//-------------------------------------------------------------------------------------------
void start_DCC() {
  digitalWrite(DCC_ENABLE,HIGH);
  digitalWrite(DCC_PROG_ENABLE,HIGH);
	etat = 1;
}
 
//-------------------------------------------------------------------------------------------
// Routine de mise hors tension
//-------------------------------------------------------------------------------------------
void stop_DCC() {
  digitalWrite(DCC_ENABLE,LOW);
  digitalWrite(DCC_PROG_ENABLE,LOW);
	etat = 0;
}

//-------------------------------------------------------------------------------------------
// Envoie à toutes les souris le nouvel état tension
//-------------------------------------------------------------------------------------------
void envoi_etat() {	// passer en émission et envoyer à toutes les souris l'état DCC
	radio.stopListening();	
  radio.openWritingPipe(pipes[0]); 
	radio.write(&text1, sizeof(text1));
  radio.openWritingPipe(pipes[1]);
	radio.write(&text1, sizeof(text1));
  radio.openWritingPipe(pipes[2]);
	radio.write(&text1, sizeof(text1));
  radio.openWritingPipe(pipes[3]);
	radio.write(&text1, sizeof(text1));
  radio.openWritingPipe(pipes[4]);
	radio.write(&text1, sizeof(text1));
  radio.openWritingPipe(pipes[5]);
	radio.write(&text1, sizeof(text1));
	delay(5);
	radio.startListening();			// se mettre en réception
}

//-------------------------------------------------------------------------------------------
// Rempli le tableau des adresses des nouvelles locos mises en fonctions
//-------------------------------------------------------------------------------------------
void enregistre_loc() {
	// checher si cette loco est déjà enregistrée dans table vitesses
	ordre_loc = 99;	// pour test d'existence
	for (int nb_loc = 0; nb_loc < nb_max_locos; nb_loc++) {	
		if(adr_loc[nb_loc] == adresse_loco) {
			ordre_loc = nb_loc;						// oui, elle existe, MAJ pointeur loco
			break;
		}
	}
	if(ordre_loc == 99) {			// loco pas encore enregistrée
		for (int nb_loc = 0; nb_loc < nb_max_locos; nb_loc++) {	
			if(adr_loc[nb_loc] == 0) {		// chercher 1er enregistr. avec adresse à 0
				adr_loc[nb_loc] = adresse_loco;	// y enregister adresse loco
				ordre_loc = nb_loc;					// mettre à jour le pointeur de la loco
				break;
			}
		}
	}
	if(ordre_loc	== 99) {			// si plus de place
		// mise à 0 des tableaux de fonctions et adresses locos
		for (int nb_loc = 0; nb_loc < nb_max_locos; nb_loc++) {	
			adr_loc[nb_loc] = 0;
			tab_fonc_B0_4[nb_loc] = 128;
			tab_fonc_B5_8[nb_loc] = 176;
			tab_fonc_B9_12[nb_loc] = 160;
			tab_fonc_B0_43_2[nb_loc] = 0;
			tab_fonc_B0_28_2[nb_loc] = 0;
		}
		adr_loc[0] = adresse_loco;	// enregister adresse loco
		ordre_loc = 0;					// mettre à jour le pointeur de la loco
	}
}

//-------------------------------------------------------------------------------------------
// restaure l'adresse loco à partir des bytes HI et LOW
//-------------------------------------------------------------------------------------------
int restaure_adr() 
{   
		int adresse = adr_loco_H ;        
    adresse = adresse << 8 ;    
    adresse = adresse | adr_loco_L ; 
		return adresse;
}
